/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __REFCOUNTED_KPTR_FAIL_SKEL_H__
#define __REFCOUNTED_KPTR_FAIL_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct refcounted_kptr_fail {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *data_A;
	} maps;
	struct {
		struct bpf_program *rbtree_refcounted_node_ref_escapes;
		struct bpf_program *rbtree_refcounted_node_ref_escapes_owning_input;
		struct bpf_program *rbtree_fail_sleepable_lock_across_rcu;
	} progs;
	struct {
		struct bpf_link *rbtree_refcounted_node_ref_escapes;
		struct bpf_link *rbtree_refcounted_node_ref_escapes_owning_input;
		struct bpf_link *rbtree_fail_sleepable_lock_across_rcu;
	} links;

#ifdef __cplusplus
	static inline struct refcounted_kptr_fail *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct refcounted_kptr_fail *open_and_load();
	static inline int load(struct refcounted_kptr_fail *skel);
	static inline int attach(struct refcounted_kptr_fail *skel);
	static inline void detach(struct refcounted_kptr_fail *skel);
	static inline void destroy(struct refcounted_kptr_fail *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
refcounted_kptr_fail__destroy(struct refcounted_kptr_fail *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
refcounted_kptr_fail__create_skeleton(struct refcounted_kptr_fail *obj);

static inline struct refcounted_kptr_fail *
refcounted_kptr_fail__open_opts(const struct bpf_object_open_opts *opts)
{
	struct refcounted_kptr_fail *obj;
	int err;

	obj = (struct refcounted_kptr_fail *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = refcounted_kptr_fail__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	refcounted_kptr_fail__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct refcounted_kptr_fail *
refcounted_kptr_fail__open(void)
{
	return refcounted_kptr_fail__open_opts(NULL);
}

static inline int
refcounted_kptr_fail__load(struct refcounted_kptr_fail *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct refcounted_kptr_fail *
refcounted_kptr_fail__open_and_load(void)
{
	struct refcounted_kptr_fail *obj;
	int err;

	obj = refcounted_kptr_fail__open();
	if (!obj)
		return NULL;
	err = refcounted_kptr_fail__load(obj);
	if (err) {
		refcounted_kptr_fail__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
refcounted_kptr_fail__attach(struct refcounted_kptr_fail *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
refcounted_kptr_fail__detach(struct refcounted_kptr_fail *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *refcounted_kptr_fail__elf_bytes(size_t *sz);

static inline int
refcounted_kptr_fail__create_skeleton(struct refcounted_kptr_fail *obj)
{
	struct bpf_object_skeleton *s;
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "refcounted_kptr_fail";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 1;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	s->maps[0].name = ".data.A";
	s->maps[0].map = &obj->maps.data_A;

	/* programs */
	s->prog_cnt = 3;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "rbtree_refcounted_node_ref_escapes";
	s->progs[0].prog = &obj->progs.rbtree_refcounted_node_ref_escapes;
	s->progs[0].link = &obj->links.rbtree_refcounted_node_ref_escapes;

	s->progs[1].name = "rbtree_refcounted_node_ref_escapes_owning_input";
	s->progs[1].prog = &obj->progs.rbtree_refcounted_node_ref_escapes_owning_input;
	s->progs[1].link = &obj->links.rbtree_refcounted_node_ref_escapes_owning_input;

	s->progs[2].name = "rbtree_fail_sleepable_lock_across_rcu";
	s->progs[2].prog = &obj->progs.rbtree_fail_sleepable_lock_across_rcu;
	s->progs[2].link = &obj->links.rbtree_fail_sleepable_lock_across_rcu;

	s->data = refcounted_kptr_fail__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *refcounted_kptr_fail__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\xe0\x13\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x0c\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x2e\x74\
\x65\x78\x74\0\x3f\x74\x63\0\x3f\x66\x65\x6e\x74\x72\x79\x2e\x73\x2f\x62\x70\
\x66\x5f\x74\x65\x73\x74\x6d\x6f\x64\x5f\x74\x65\x73\x74\x5f\x72\x65\x61\x64\0\
\x2e\x64\x61\x74\x61\x2e\x41\0\x6c\x69\x63\x65\x6e\x73\x65\0\x72\x65\x66\x63\
\x6f\x75\x6e\x74\x65\x64\x5f\x6b\x70\x74\x72\x5f\x66\x61\x69\x6c\x2e\x63\0\x4c\
\x42\x42\x30\x5f\x33\0\x6c\x65\x73\x73\0\x4c\x42\x42\x31\x5f\x32\0\x4c\x42\x42\
\x32\x5f\x32\0\x4c\x42\x42\x33\x5f\x32\0\x72\x62\x74\x72\x65\x65\x5f\x72\x65\
\x66\x63\x6f\x75\x6e\x74\x65\x64\x5f\x6e\x6f\x64\x65\x5f\x72\x65\x66\x5f\x65\
\x73\x63\x61\x70\x65\x73\0\x62\x70\x66\x5f\x6f\x62\x6a\x5f\x6e\x65\x77\x5f\x69\
\x6d\x70\x6c\0\x67\x6c\x6f\x63\x6b\0\x67\x72\x6f\x6f\x74\0\x62\x70\x66\x5f\x72\
\x62\x74\x72\x65\x65\x5f\x61\x64\x64\x5f\x69\x6d\x70\x6c\0\x62\x70\x66\x5f\x72\
\x65\x66\x63\x6f\x75\x6e\x74\x5f\x61\x63\x71\x75\x69\x72\x65\x5f\x69\x6d\x70\
\x6c\0\x72\x62\x74\x72\x65\x65\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\x65\x64\x5f\
\x6e\x6f\x64\x65\x5f\x72\x65\x66\x5f\x65\x73\x63\x61\x70\x65\x73\x5f\x6f\x77\
\x6e\x69\x6e\x67\x5f\x69\x6e\x70\x75\x74\0\x72\x62\x74\x72\x65\x65\x5f\x66\x61\
\x69\x6c\x5f\x73\x6c\x65\x65\x70\x61\x62\x6c\x65\x5f\x6c\x6f\x63\x6b\x5f\x61\
\x63\x72\x6f\x73\x73\x5f\x72\x63\x75\0\x62\x70\x66\x5f\x72\x63\x75\x5f\x72\x65\
\x61\x64\x5f\x6c\x6f\x63\x6b\0\x62\x70\x66\x5f\x72\x63\x75\x5f\x72\x65\x61\x64\
\x5f\x75\x6e\x6c\x6f\x63\x6b\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x65\
\x6c\x3f\x74\x63\0\x2e\x72\x65\x6c\x3f\x66\x65\x6e\x74\x72\x79\x2e\x73\x2f\x62\
\x70\x66\x5f\x74\x65\x73\x74\x6d\x6f\x64\x5f\x74\x65\x73\x74\x5f\x72\x65\x61\
\x64\0\x2e\x42\x54\x46\0\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4b\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x04\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x62\0\0\0\0\0\x04\0\xf8\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x69\0\0\0\x02\0\x03\0\0\0\0\0\0\0\0\0\x30\0\0\0\0\0\0\0\x6e\0\0\0\0\0\
\x03\0\x28\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x75\0\0\0\0\0\x04\0\xe0\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x05\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x7c\0\0\
\0\0\0\x05\0\xc8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x83\0\0\0\x12\0\x04\0\0\0\0\0\0\
\0\0\0\0\x01\0\0\0\0\0\0\xa6\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\xb7\0\0\0\x11\x02\x06\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\xbd\0\0\0\x11\x02\
\x06\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xc3\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\xd7\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf1\0\0\0\
\x12\0\x04\0\0\x01\0\0\0\0\0\0\xe8\0\0\0\0\0\0\0\x21\x01\0\0\x12\0\x05\0\0\0\0\
\0\0\0\0\0\xd8\0\0\0\0\0\0\0\x47\x01\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x59\x01\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x6d\x01\0\0\x11\0\
\x07\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\x79\x22\xf0\xff\0\0\0\0\x79\x11\xf0\
\xff\0\0\0\0\xb7\0\0\0\x01\0\0\0\xcd\x21\x01\0\0\0\0\0\xb7\0\0\0\0\0\0\0\x95\0\
\0\0\0\0\0\0\x18\x01\0\0\x07\0\0\0\0\0\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\
\0\0\xff\xff\xff\xff\xbf\x06\0\0\0\0\0\0\xb7\0\0\0\x01\0\0\0\x15\x06\x18\0\0\0\
\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5d\0\0\0\xbf\x62\0\0\0\0\0\
\0\x07\x02\0\0\x10\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x03\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\xb7\x04\0\0\0\0\0\0\xb7\x05\0\0\0\0\0\0\x85\x10\0\0\xff\xff\
\xff\xff\xbf\x61\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\
\xbf\x06\0\0\0\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5e\0\0\0\
\xb7\0\0\0\x02\0\0\0\x15\x06\x03\0\0\0\0\0\xb7\x01\0\0\x02\0\0\0\x7b\x16\0\0\0\
\0\0\0\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\x18\x01\0\0\x07\0\0\0\0\0\0\0\0\0\0\
\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\xbf\x06\0\0\0\0\0\0\xb7\0\0\
\0\x01\0\0\0\x15\x06\x15\0\0\0\0\0\xbf\x61\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\
\x10\0\0\xff\xff\xff\xff\xb7\x01\0\0\x02\0\0\0\x7b\x10\0\0\0\0\0\0\x18\x01\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5d\0\0\0\x07\x06\0\0\x10\0\0\0\x18\x01\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\xbf\x62\0\0\0\0\0\0\x18\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\xb7\x04\0\0\0\0\0\0\xb7\x05\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\x18\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5e\0\0\0\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\
\0\0\0\x18\x01\0\0\x07\0\0\0\0\0\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\
\xff\xff\xff\xff\xbf\x06\0\0\0\0\0\0\x15\x06\x13\0\0\0\0\0\x85\x10\0\0\xff\xff\
\xff\xff\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5d\0\0\0\x07\x06\0\0\
\x10\0\0\0\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xbf\x62\0\0\0\0\0\0\x18\x03\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\xb7\x04\0\0\0\0\0\0\xb7\x05\0\0\0\0\0\0\x85\x10\0\0\
\xff\xff\xff\xff\x85\x10\0\0\xff\xff\xff\xff\x85\x10\0\0\xff\xff\xff\xff\x18\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x5e\0\0\0\x85\x10\0\0\xff\xff\xff\
\xff\xb7\0\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x47\x50\x4c\0\0\0\0\0\x18\0\0\0\0\0\0\0\x0a\0\0\0\x0b\0\0\0\x38\0\0\
\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\x60\0\0\0\0\0\0\0\x01\0\0\0\x0d\0\0\0\x70\0\0\0\
\0\0\0\0\x01\0\0\0\x02\0\0\0\x90\0\0\0\0\0\0\0\x0a\0\0\0\x0e\0\0\0\xa8\0\0\0\0\
\0\0\0\x0a\0\0\0\x0f\0\0\0\xb8\0\0\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\x18\x01\0\0\0\
\0\0\0\x0a\0\0\0\x0b\0\0\0\x48\x01\0\0\0\0\0\0\x0a\0\0\0\x0f\0\0\0\x60\x01\0\0\
\0\0\0\0\x01\0\0\0\x0c\0\0\0\x80\x01\0\0\0\0\0\0\x01\0\0\0\x0d\0\0\0\x98\x01\0\
\0\0\0\0\0\x01\0\0\0\x02\0\0\0\xb8\x01\0\0\0\0\0\0\x0a\0\0\0\x0e\0\0\0\xc0\x01\
\0\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\x18\0\0\0\0\0\0\0\x0a\0\0\0\x0b\0\0\0\x30\0\0\
\0\0\0\0\0\x0a\0\0\0\x12\0\0\0\x38\0\0\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\x58\0\0\0\
\0\0\0\0\x01\0\0\0\x0d\0\0\0\x70\0\0\0\0\0\0\0\x01\0\0\0\x02\0\0\0\x90\0\0\0\0\
\0\0\0\x0a\0\0\0\x0e\0\0\0\x98\0\0\0\0\0\0\0\x0a\0\0\0\x13\0\0\0\xa0\0\0\0\0\0\
\0\0\x0a\0\0\0\x12\0\0\0\xa8\0\0\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\xc0\0\0\0\0\0\0\
\0\x0a\0\0\0\x13\0\0\0\x9f\xeb\x01\0\x18\0\0\0\0\0\0\0\xe0\x03\0\0\xe0\x03\0\0\
\xb9\x04\0\0\0\0\0\0\0\0\0\x02\0\0\0\0\0\0\0\0\x01\0\0\x0d\x03\0\0\0\x01\0\0\0\
\x01\0\0\0\x05\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\x01\x0a\0\0\0\x01\0\0\x0c\x02\
\0\0\0\x2d\0\0\0\0\0\0\x11\x04\0\0\0\xff\xff\xff\xff\x49\0\0\0\0\0\0\x11\x04\0\
\0\0\xff\xff\xff\xff\x89\0\0\0\x04\0\0\x04\x38\0\0\0\x96\0\0\0\x03\0\0\0\0\0\0\
\0\x9a\0\0\0\x03\0\0\0\x40\0\0\0\x9f\0\0\0\x08\0\0\0\x80\0\0\0\xa4\0\0\0\x09\0\
\0\0\x80\x01\0\0\xad\0\0\0\0\0\0\x04\x20\0\0\0\xb9\0\0\0\0\0\0\x04\x04\0\0\0\0\
\0\0\0\x02\0\0\x0d\x01\0\0\0\0\0\0\0\x0b\0\0\0\0\0\0\0\x01\0\0\0\xc6\0\0\0\0\0\
\0\x08\x0c\0\0\0\xcc\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\0\xdf\0\0\0\x02\0\0\x0c\
\x0a\0\0\0\0\0\0\0\x05\0\0\x0d\x0f\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x12\0\0\0\0\
\0\0\0\x13\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x0b\0\0\0\xf0\0\0\0\0\0\0\x01\x04\0\
\0\0\x20\0\0\x01\0\0\0\0\0\0\0\x02\x11\0\0\0\xf4\0\0\0\0\0\0\x04\x10\0\0\0\0\0\
\0\0\0\0\0\x02\x08\0\0\0\0\0\0\0\0\0\0\x02\x14\0\0\0\0\0\0\0\x02\0\0\x0d\x15\0\
\0\0\0\0\0\0\x12\0\0\0\0\0\0\0\x17\0\0\0\0\x01\0\0\0\0\0\x08\x16\0\0\0\x05\x01\
\0\0\0\0\0\x01\x01\0\0\0\x08\0\0\x04\0\0\0\0\0\0\0\x02\x18\0\0\0\0\0\0\0\0\0\0\
\x0a\x08\0\0\0\x0b\x01\0\0\x02\0\0\x0c\x0e\0\0\0\0\0\0\0\x02\0\0\x0d\x01\0\0\0\
\0\0\0\0\x01\0\0\0\0\0\0\0\x01\0\0\0\x1f\x01\0\0\x02\0\0\x0c\x1a\0\0\0\0\0\0\0\
\x02\0\0\x0d\x15\0\0\0\x39\x01\0\0\x12\0\0\0\x3b\x01\0\0\x17\0\0\0\x3d\x01\0\0\
\0\0\0\x0c\x1c\0\0\0\x42\x01\0\0\x01\0\0\x0c\x02\0\0\0\x2d\0\0\0\0\0\0\x11\x1e\
\0\0\0\xff\xff\xff\xff\x72\x01\0\0\0\0\0\x11\x1e\0\0\0\xff\xff\xff\xff\0\0\0\0\
\0\0\0\x02\x0c\0\0\0\0\0\0\0\x01\0\0\x0d\x0f\0\0\0\x01\0\0\0\x21\0\0\0\xb1\x01\
\0\0\x01\0\0\x0c\x22\0\0\0\x2d\0\0\0\0\0\0\x11\x23\0\0\0\xff\xff\xff\xff\xd7\
\x01\0\0\0\0\0\x11\x23\0\0\0\xff\xff\xff\xff\0\0\0\0\0\0\0\x0d\0\0\0\0\x23\x02\
\0\0\x02\0\0\x0c\x26\0\0\0\x35\x02\0\0\x02\0\0\x0c\x26\0\0\0\x49\x02\0\0\x01\0\
\0\x04\x04\0\0\0\x57\x02\0\0\x2a\0\0\0\0\0\0\0\x5b\x02\0\0\0\0\0\x08\x2b\0\0\0\
\x61\x02\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\x6e\x02\0\0\0\0\0\x0e\x29\0\0\0\x01\
\0\0\0\x74\x02\0\0\0\0\0\x0e\x11\0\0\0\x01\0\0\0\x7a\x02\0\0\0\0\0\x11\x2d\0\0\
\0\xff\xff\xff\xff\x95\x02\0\0\0\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\
\x03\0\0\0\0\x2f\0\0\0\x31\0\0\0\x04\0\0\0\x9a\x02\0\0\0\0\0\x01\x04\0\0\0\x20\
\0\0\0\xae\x02\0\0\0\0\0\x0e\x30\0\0\0\x01\0\0\0\x78\x04\0\0\x02\0\0\x0f\x18\0\
\0\0\x2c\0\0\0\0\0\0\0\x04\0\0\0\x2d\0\0\0\x08\0\0\0\x10\0\0\0\x80\x04\0\0\x01\
\0\0\x0f\x04\0\0\0\x32\0\0\0\0\0\0\0\x04\0\0\0\x88\x04\0\0\x05\0\0\x0f\0\0\0\0\
\x0d\0\0\0\0\0\0\0\0\0\0\0\x19\0\0\0\0\0\0\0\0\0\0\0\x1b\0\0\0\0\0\0\0\0\0\0\0\
\x27\0\0\0\0\0\0\0\0\0\0\0\x28\0\0\0\0\0\0\0\0\0\0\0\0\x63\x74\x78\0\x6c\x6f\
\x6e\x67\0\x72\x62\x74\x72\x65\x65\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\x65\x64\
\x5f\x6e\x6f\x64\x65\x5f\x72\x65\x66\x5f\x65\x73\x63\x61\x70\x65\x73\0\x63\x6f\
\x6d\x6d\x65\x6e\x74\x3a\x74\x65\x73\x74\x5f\x65\x78\x70\x65\x63\x74\x5f\x66\
\x61\x69\x6c\x75\x72\x65\0\x63\x6f\x6d\x6d\x65\x6e\x74\x3a\x74\x65\x73\x74\x5f\
\x65\x78\x70\x65\x63\x74\x5f\x6d\x73\x67\x3d\x55\x6e\x72\x65\x6c\x65\x61\x73\
\x65\x64\x20\x72\x65\x66\x65\x72\x65\x6e\x63\x65\x20\x69\x64\x3d\x34\x20\x61\
\x6c\x6c\x6f\x63\x5f\x69\x6e\x73\x6e\x3d\x32\x31\0\x6e\x6f\x64\x65\x5f\x61\x63\
\x71\x75\x69\x72\x65\0\x6b\x65\x79\0\x64\x61\x74\x61\0\x6e\x6f\x64\x65\0\x72\
\x65\x66\x63\x6f\x75\x6e\x74\0\x62\x70\x66\x5f\x72\x62\x5f\x6e\x6f\x64\x65\0\
\x62\x70\x66\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\0\x5f\x5f\x75\x36\x34\0\x75\
\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\x20\x6c\x6f\x6e\x67\0\x62\x70\
\x66\x5f\x6f\x62\x6a\x5f\x6e\x65\x77\x5f\x69\x6d\x70\x6c\0\x69\x6e\x74\0\x62\
\x70\x66\x5f\x72\x62\x5f\x72\x6f\x6f\x74\0\x62\x6f\x6f\x6c\0\x5f\x42\x6f\x6f\
\x6c\0\x62\x70\x66\x5f\x72\x62\x74\x72\x65\x65\x5f\x61\x64\x64\x5f\x69\x6d\x70\
\x6c\0\x62\x70\x66\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\x5f\x61\x63\x71\x75\x69\
\x72\x65\x5f\x69\x6d\x70\x6c\0\x61\0\x62\0\x6c\x65\x73\x73\0\x72\x62\x74\x72\
\x65\x65\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\x65\x64\x5f\x6e\x6f\x64\x65\x5f\
\x72\x65\x66\x5f\x65\x73\x63\x61\x70\x65\x73\x5f\x6f\x77\x6e\x69\x6e\x67\x5f\
\x69\x6e\x70\x75\x74\0\x63\x6f\x6d\x6d\x65\x6e\x74\x3a\x74\x65\x73\x74\x5f\x65\
\x78\x70\x65\x63\x74\x5f\x6d\x73\x67\x3d\x55\x6e\x72\x65\x6c\x65\x61\x73\x65\
\x64\x20\x72\x65\x66\x65\x72\x65\x6e\x63\x65\x20\x69\x64\x3d\x33\x20\x61\x6c\
\x6c\x6f\x63\x5f\x69\x6e\x73\x6e\x3d\x39\0\x72\x62\x74\x72\x65\x65\x5f\x66\x61\
\x69\x6c\x5f\x73\x6c\x65\x65\x70\x61\x62\x6c\x65\x5f\x6c\x6f\x63\x6b\x5f\x61\
\x63\x72\x6f\x73\x73\x5f\x72\x63\x75\0\x63\x6f\x6d\x6d\x65\x6e\x74\x3a\x74\x65\
\x73\x74\x5f\x65\x78\x70\x65\x63\x74\x5f\x6d\x73\x67\x3d\x66\x75\x6e\x63\x74\
\x69\x6f\x6e\x20\x63\x61\x6c\x6c\x73\x20\x61\x72\x65\x20\x6e\x6f\x74\x20\x61\
\x6c\x6c\x6f\x77\x65\x64\x20\x77\x68\x69\x6c\x65\x20\x68\x6f\x6c\x64\x69\x6e\
\x67\x20\x61\x20\x6c\x6f\x63\x6b\0\x62\x70\x66\x5f\x72\x63\x75\x5f\x72\x65\x61\
\x64\x5f\x6c\x6f\x63\x6b\0\x62\x70\x66\x5f\x72\x63\x75\x5f\x72\x65\x61\x64\x5f\
\x75\x6e\x6c\x6f\x63\x6b\0\x62\x70\x66\x5f\x73\x70\x69\x6e\x5f\x6c\x6f\x63\x6b\
\0\x76\x61\x6c\0\x5f\x5f\x75\x33\x32\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\
\x6e\x74\0\x67\x6c\x6f\x63\x6b\0\x67\x72\x6f\x6f\x74\0\x63\x6f\x6e\x74\x61\x69\
\x6e\x73\x3a\x6e\x6f\x64\x65\x5f\x61\x63\x71\x75\x69\x72\x65\x3a\x6e\x6f\x64\
\x65\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\
\x54\x59\x50\x45\x5f\x5f\0\x5f\x6c\x69\x63\x65\x6e\x73\x65\0\x2f\x62\x75\x69\
\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\
\x65\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x34\x34\x36\x2e\x65\x6c\
\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x34\x34\x36\x2e\
\x65\x6c\x39\x2e\x70\x70\x63\x36\x34\x6c\x65\x2f\x74\x6f\x6f\x6c\x73\x2f\x74\
\x65\x73\x74\x69\x6e\x67\x2f\x73\x65\x6c\x66\x74\x65\x73\x74\x73\x2f\x62\x70\
\x66\x2f\x70\x72\x6f\x67\x73\x2f\x72\x65\x66\x63\x6f\x75\x6e\x74\x65\x64\x5f\
\x6b\x70\x74\x72\x5f\x66\x61\x69\x6c\x2e\x63\0\x09\x72\x65\x74\x75\x72\x6e\x20\
\x6e\x6f\x64\x65\x5f\x61\x2d\x3e\x6b\x65\x79\x20\x3c\x20\x6e\x6f\x64\x65\x5f\
\x62\x2d\x3e\x6b\x65\x79\x3b\0\x09\x6e\x20\x3d\x20\x62\x70\x66\x5f\x6f\x62\x6a\
\x5f\x6e\x65\x77\x28\x74\x79\x70\x65\x6f\x66\x28\x2a\x6e\x29\x29\x3b\0\x09\x69\
\x66\x20\x28\x21\x6e\x29\0\x09\x62\x70\x66\x5f\x73\x70\x69\x6e\x5f\x6c\x6f\x63\
\x6b\x28\x26\x67\x6c\x6f\x63\x6b\x29\x3b\0\x09\x62\x70\x66\x5f\x72\x62\x74\x72\
\x65\x65\x5f\x61\x64\x64\x28\x26\x67\x72\x6f\x6f\x74\x2c\x20\x26\x6e\x2d\x3e\
\x6e\x6f\x64\x65\x2c\x20\x6c\x65\x73\x73\x29\x3b\0\x09\x6d\x20\x3d\x20\x62\x70\
\x66\x5f\x72\x65\x66\x63\x6f\x75\x6e\x74\x5f\x61\x63\x71\x75\x69\x72\x65\x28\
\x6e\x29\x3b\0\x09\x62\x70\x66\x5f\x73\x70\x69\x6e\x5f\x75\x6e\x6c\x6f\x63\x6b\
\x28\x26\x67\x6c\x6f\x63\x6b\x29\x3b\0\x09\x69\x66\x20\x28\x21\x6d\x29\0\x09\
\x6d\x2d\x3e\x6b\x65\x79\x20\x3d\x20\x32\x3b\0\x7d\0\x09\x62\x70\x66\x5f\x72\
\x63\x75\x5f\x72\x65\x61\x64\x5f\x6c\x6f\x63\x6b\x28\x29\x3b\0\x09\x62\x70\x66\
\x5f\x72\x63\x75\x5f\x72\x65\x61\x64\x5f\x75\x6e\x6c\x6f\x63\x6b\x28\x29\x3b\0\
\x69\x6e\x74\x20\x42\x50\x46\x5f\x50\x52\x4f\x47\x28\x72\x62\x74\x72\x65\x65\
\x5f\x66\x61\x69\x6c\x5f\x73\x6c\x65\x65\x70\x61\x62\x6c\x65\x5f\x6c\x6f\x63\
\x6b\x5f\x61\x63\x72\x6f\x73\x73\x5f\x72\x63\x75\x2c\0\x30\0\x2e\x64\x61\x74\
\x61\x2e\x41\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x6b\x73\x79\x6d\x73\0\x2e\x74\
\x65\x78\x74\0\x3f\x74\x63\0\x3f\x66\x65\x6e\x74\x72\x79\x2e\x73\x2f\x62\x70\
\x66\x5f\x74\x65\x73\x74\x6d\x6f\x64\x5f\x74\x65\x73\x74\x5f\x72\x65\x61\x64\0\
\0\0\0\0\0\0\0\x9f\xeb\x01\0\x20\0\0\0\0\0\0\0\x3c\0\0\0\x3c\0\0\0\x0c\x02\0\0\
\x48\x02\0\0\x44\0\0\0\x08\0\0\0\x8f\x04\0\0\x01\0\0\0\0\0\0\0\x1d\0\0\0\x95\
\x04\0\0\x02\0\0\0\0\0\0\0\x04\0\0\0\0\x01\0\0\x1e\0\0\0\x99\x04\0\0\x01\0\0\0\
\0\0\0\0\x23\0\0\0\x10\0\0\0\x8f\x04\0\0\x04\0\0\0\0\0\0\0\xb7\x02\0\0\x39\x03\
\0\0\x1f\x7c\0\0\x08\0\0\0\xb7\x02\0\0\x39\x03\0\0\x11\x7c\0\0\x18\0\0\0\xb7\
\x02\0\0\x39\x03\0\0\x15\x7c\0\0\x28\0\0\0\xb7\x02\0\0\x39\x03\0\0\x02\x7c\0\0\
\x95\x04\0\0\x11\0\0\0\0\0\0\0\xb7\x02\0\0\x5c\x03\0\0\x06\xa0\0\0\x30\0\0\0\
\xb7\x02\0\0\x7a\x03\0\0\x06\xa4\0\0\x38\0\0\0\xb7\x02\0\0\x83\x03\0\0\x02\xb0\
\0\0\x50\0\0\0\xb7\x02\0\0\x9b\x03\0\0\x02\xb4\0\0\x98\0\0\0\xb7\x02\0\0\xc4\
\x03\0\0\x06\xbc\0\0\xb8\0\0\0\xb7\x02\0\0\xe2\x03\0\0\x02\xc0\0\0\xd8\0\0\0\
\xb7\x02\0\0\xfc\x03\0\0\x06\xc4\0\0\xe8\0\0\0\xb7\x02\0\0\x05\x04\0\0\x09\xd0\
\0\0\xf8\0\0\0\xb7\x02\0\0\x12\x04\0\0\x01\xd8\0\0\0\x01\0\0\xb7\x02\0\0\x5c\
\x03\0\0\x06\xf8\0\0\x30\x01\0\0\xb7\x02\0\0\x7a\x03\0\0\x06\xfc\0\0\x38\x01\0\
\0\xb7\x02\0\0\xc4\x03\0\0\x06\x0c\x01\0\x58\x01\0\0\xb7\x02\0\0\x05\x04\0\0\
\x09\x10\x01\0\x60\x01\0\0\xb7\x02\0\0\x83\x03\0\0\x02\x18\x01\0\x78\x01\0\0\
\xb7\x02\0\0\x9b\x03\0\0\x02\x1c\x01\0\xc0\x01\0\0\xb7\x02\0\0\xe2\x03\0\0\x02\
\x20\x01\0\xe0\x01\0\0\xb7\x02\0\0\x12\x04\0\0\x01\x2c\x01\0\x99\x04\0\0\x0a\0\
\0\0\0\0\0\0\xb7\x02\0\0\x5c\x03\0\0\x06\x54\x01\0\x28\0\0\0\xb7\x02\0\0\x7a\
\x03\0\0\x06\x58\x01\0\x30\0\0\0\xb7\x02\0\0\x14\x04\0\0\x02\x68\x01\0\x38\0\0\
\0\xb7\x02\0\0\x83\x03\0\0\x02\x6c\x01\0\x50\0\0\0\xb7\x02\0\0\x9b\x03\0\0\x02\
\x70\x01\0\x98\0\0\0\xb7\x02\0\0\x2a\x04\0\0\x02\x74\x01\0\xa0\0\0\0\xb7\x02\0\
\0\x14\x04\0\0\x02\x7c\x01\0\xa8\0\0\0\xb7\x02\0\0\xe2\x03\0\0\x02\x80\x01\0\
\xc0\0\0\0\xb7\x02\0\0\x2a\x04\0\0\x02\x84\x01\0\xc8\0\0\0\xb7\x02\0\0\x42\x04\
\0\0\x05\x3c\x01\0\x10\0\0\0\x95\x04\0\0\x02\0\0\0\0\0\0\0\x07\0\0\0\x76\x04\0\
\0\x06\0\0\0\0\x01\0\0\x07\0\0\0\x76\x04\0\0\x06\0\0\0\x99\x04\0\0\x01\0\0\0\0\
\0\0\0\x07\0\0\0\x76\x04\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\x01\0\0\0\x03\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\
\0\0\0\0\0\0\xb0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x09\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf0\x01\0\0\0\0\0\0\
\xf8\x01\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x11\
\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xe8\x03\0\0\0\0\0\0\x30\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x17\0\0\0\x01\0\0\
\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\x04\0\0\0\0\0\0\xe8\x01\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x1b\0\0\0\x01\0\0\0\x06\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x06\0\0\0\0\0\0\xd8\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x3b\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\xd8\x06\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x43\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf0\
\x06\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\x76\x01\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf8\x06\0\0\0\0\
\0\0\xe0\0\0\0\0\0\0\0\x02\0\0\0\x04\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\
\x7e\x01\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xd8\x07\0\0\0\0\0\0\
\xa0\0\0\0\0\0\0\0\x02\0\0\0\x05\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xa2\
\x01\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x78\x08\0\0\0\0\0\0\xb1\x08\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xa7\x01\0\0\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x30\x11\0\0\0\0\0\0\xac\x02\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct refcounted_kptr_fail *refcounted_kptr_fail::open(const struct bpf_object_open_opts *opts) { return refcounted_kptr_fail__open_opts(opts); }
struct refcounted_kptr_fail *refcounted_kptr_fail::open_and_load() { return refcounted_kptr_fail__open_and_load(); }
int refcounted_kptr_fail::load(struct refcounted_kptr_fail *skel) { return refcounted_kptr_fail__load(skel); }
int refcounted_kptr_fail::attach(struct refcounted_kptr_fail *skel) { return refcounted_kptr_fail__attach(skel); }
void refcounted_kptr_fail::detach(struct refcounted_kptr_fail *skel) { refcounted_kptr_fail__detach(skel); }
void refcounted_kptr_fail::destroy(struct refcounted_kptr_fail *skel) { refcounted_kptr_fail__destroy(skel); }
const void *refcounted_kptr_fail::elf_bytes(size_t *sz) { return refcounted_kptr_fail__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
refcounted_kptr_fail__assert(struct refcounted_kptr_fail *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __REFCOUNTED_KPTR_FAIL_SKEL_H__ */
